/*
 *  Copyright (C) 2015  Thadeu Lima de Souza Cascardo <cascardo@cascardo.eti.br>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef _DECLARACAO_H
#define _DECLARACAO_H

#include "list.h"
#include "contribuinte.h"
#include "conjuge.h"
#include "sistema.h"

enum {
	SIMPLES,
	COMPLETA,
	FORCA_SIMPLES,
	FORCA_COMPLETA,
};

struct declaracao {
	int ano;
	char *cpf;
	char *nome;
	struct list *rendimento;
	struct list *isentos;
	struct list *pagamentos;
	struct list *bens;
	struct list *dependentes;
	struct contribuinte contribuinte;
	struct conjuge conjuge;
	struct sistema sistema;
	long long pago;
	long long retido;
	long long devido;
	long long pagar;
	long long restituicao;
	int obrigatoria;
	int tipo;
	char *recibo;
	char *retifica;
	char *banco;
	char *agencia;
	char *contacorrente;
	char *dvconta;
	int linhas[100]; /* Número de linhas escritas de cada tipo. */
	struct pmhash *totais;
	unsigned long hash;
	unsigned long rhash;
	int verbose;
};

struct declaracao * declaracao_new(int ano);
void declaracao_free(struct declaracao *dec);

#endif
